#!/usr/bin/perl

#------------------------------------------------------------#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) 
 {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
 }
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item(@pairs) 
 {
  ($key, $content) = split (/=/, $item, 2);
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  $FORM{$key} = $content;
 }
#------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  open FILE,$FORM{'main_file'};
  $stat_info .= ($_[1]."    ".$_[0]."<br>");
  binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.save_changes_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }

#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";

#     
my $save_patch_folder = $FORM{'save_patch_folder'}.$FORM{'save_patch_prefix'};
   #   
   $save_patch_folder =~ s/\\{2,}/\\/g;
   #   
   $save_patch_folder .= "{!end!}";
#   
my $patch_file_name = $FORM{'save_patch_name'}.$FORM{'save_patch_suffix'};
   #  
   $patch_file_name =~ s/\\{1,}//g;
#    
my $patch_file_ext = $FORM{'patch_ext'};

#  
$stat_info .= "<b>  ()</b> ...<br>";
#     
my $backup_stat = "";

#    
my $start_position = $FORM{'processing_start_position'};
#    
my $end_position = $FORM{'processing_end_position'};
#     
my $processing_strings = $FORM{'processing_count'};
#      
my $processed_strings = 0;

#     
my @patch_strings;
   if($FORM{'patched_numbers_joined'} ne "{!range!}")
    { @patch_strings = split ",",$FORM{'patched_numbers_joined'}; }
   else{ for my $n ($start_position..$end_position){ push @patch_strings,$n; } }

#     
my @patch_content;
# -:  =  ;  =  
my %patch_elements;

#      
$save_patch_folder =~ s/\\/{!slash!}/g;
my @all_patch_folders = split "{!slash!}",$save_patch_folder;

#  
my $current_subfolders = @all_patch_folders[0]."\\";
#          
for my $f (1..$#all_patch_folders)
 { #if($f eq $#all_patch_folders){ @all_patch_folders[$f] =~ /{!end!}/; };
   if(@all_patch_folders[$f] =~ s/{!end!}//){ $patch_file_name = @all_patch_folders[$f].$patch_file_name; }
   else{ $current_subfolders .= @all_patch_folders[$f]."\\"; }
   if(!-r $current_subfolders){ mkdir $current_subfolders; }; }
$save_patch_folder = $current_subfolders;

#  :      
if($FORM{'patch_format'} ne "strings_csv" && $FORM{'patch_format'} ne "strings_num")
 {
  $stat_info .= "    tlk-...<br>";

  #   TLK-
  if(!-r $FORM{'main_file'})
   { $stat_info .= (":  tlk-       !<br>");
     reset_document(); };
  open FILE,$FORM{'main_file'};
  #     TLK- ( )
  (undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
  #   TLK-
  close FILE;
  $stat_info .= ("->     ... ");
  read_block(0,20,$header);
  #   TLK- 
  $file_type = substr $header,0,4;
  if($file_type ne "TLK ")
   { $stat_info .= (":   ".$file_type."   !<br>"); reset_document(); };
  #   TLK-
  $file_version = substr $header,4,4;
  #      TLK-
  $file_strings = ($file_version eq "V3.0") ? get_DWORD($header,12) - 1 : get_DWORD($header,10) - 1;
  #           TLK-
  $strings_offset = ($file_version eq "V3.0") ? get_DWORD($header,16) : get_DWORD($header,14);
  #     TLK-
  if($file_version eq "V3.0"){ $header_length = 20; $string_data_length = 40; }
  else{ $header_length = 18; $string_data_length = 26; }
  #         TLK-
  if($FORM{'string_number'} > $file_strings){ $FORM{'string_number'} = $file_strings; };

  $stat_info .= "->       ... ";
  read_block($header_length,$strings_offset-$header_length,$strings_data_table);

  #       
  if($FORM{'patched_contents_joined'} ne "{!none!}")
   { @patch_content = split "{!join!}",$FORM{'patched_contents_joined'}; }
  #  :        
  else
   {
    $stat_info .= "->     ... ";
    read_block($strings_offset,$file_size-$strings_offset,$strings_content);

    #  :    tlk- V3.0
    if($file_version eq "V3.0")
     {
      for my $n (@patch_strings)
       {
        #    
        my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
        #   
        my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
        #    
        push @patch_content,(substr $strings_content,$current_OffsetToString,$current_StringSize);
       }
     #  :    tlk- V3.0
     }
    #  :    tlk- V1
    elsif($file_version eq "V1  ")
     {
      for my $n (@patch_strings)
       {
        my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
        my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
        push @patch_content,(substr $strings_content,$current_OffsetToString,$current_StringSize);
       }
     #  :    tlk- V1
     }
   #  :        
   }
 #  :      
 }

#    
my $patch_content;
my $support_patch_content;

$stat_info .= "  ()...<br>";

#  :  TXT-
if($FORM{'patch_format'} eq "nfu_txt")
 {
  $stat_info .= "-> TXT ( )<br>";
  if($FORM{'sorting_by_string_number'} eq 1)
   {
    $stat_info .= "->     <br>";
    for my $cn (0..$#patch_strings)
		 { $patch_elements{$patch_strings[$cn]} = @patch_content[$cn]; }

    if($file_version eq "V3.0")
     {
      foreach my $n (sort {$a <=> $b} keys %patch_elements)
       {
        my $current_Flags = get_WORD((substr $strings_data_table,40*$n,4));
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,8; $current_SoundResRef =~ s/\W//g;
        my $current_VolumeVariance = get_DWORD((substr $strings_data_table,40*$n+20,4));
        my $current_PitchVariance = get_DWORD((substr $strings_data_table,40*$n+24,4));
        my $current_SoundLength = unpack "f", (substr $strings_data_table,40*$n+36,4);
			  $patch_content .= ("StringRef: ".$n." Flags: ".$current_Flags." SoundResRef: ".$current_SoundResRef." VolumeVariance: ".$current_VolumeVariance." PitchVariance: ".$current_PitchVariance." SoundLength: ".$current_SoundLength."\n".$patch_elements{$n}."\n\n");
        $processed_string++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      foreach my $n (sort {$a <=> $b} keys %patch_elements)
       {
        my $current_Flags = get_WORD((substr $strings_data_table,26*$n,2));
        my $current_SoundResRef = substr $strings_data_table,26*$n+2,8; $current_SoundResRef =~ s/\W//g;
        my $current_VolumeVariance = get_DWORD((substr $strings_data_table,26*$n+10,4));
        my $current_PitchVariance = get_DWORD((substr $strings_data_table,26*$n+14,4));
        my $current_SoundLength = "";
        $patch_content .= ("StringRef: ".$n." Flags: ".$current_Flags." SoundResRef: ".$current_SoundResRef." VolumeVariance: ".$current_VolumeVariance." PitchVariance: ".$current_PitchVariance." SoundLength: ".$current_SoundLength."\n".$patch_elements{$n}."\n\n");
        $processed_string++;
       }
     }
   }
  elsif($FORM{'sorting_by_string_number'} eq 0)
   {
    $stat_info .= "->      <br>";
    if($file_version eq "V3.0")
     {
      for my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];
				my $current_Flags = get_WORD((substr $strings_data_table,40*$n,4));
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,8; $current_SoundResRef =~ s/\W//g;
        my $current_VolumeVariance = get_DWORD((substr $strings_data_table,40*$n+20,4));
        my $current_PitchVariance = get_DWORD((substr $strings_data_table,40*$n+24,4));
        my $current_SoundLength = unpack "f", (substr $strings_data_table,40*$n+36,4);
        $patch_content .= ("StringRef: ".@patch_strings[$cn]." Flags: ".$current_Flags." SoundResRef: ".$current_SoundResRef." VolumeVariance: ".$current_VolumeVariance." PitchVariance: ".$current_PitchVariance." SoundLength: ".$current_SoundLength."\n".@patch_content[$cn]."\n\n");
        $processed_string++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];
        my $current_Flags = get_WORD((substr $strings_data_table,26*$n,2));
        my $current_SoundResRef = substr $strings_data_table,26*$n+2,8; $current_SoundResRef =~ s/\W//g;
        my $current_VolumeVariance = get_DWORD((substr $strings_data_table,26*$n+10,4));
        my $current_PitchVariance = get_DWORD((substr $strings_data_table,26*$n+14,4));
        my $current_SoundLength = "";
        $patch_content .= ("StringRef: ".@patch_strings[$cn]." Flags: ".$current_Flags." SoundResRef: ".$current_SoundResRef." VolumeVariance: ".$current_VolumeVariance." PitchVariance: ".$current_PitchVariance." SoundLength: ".$current_SoundLength."\n".@patch_content[$cn]."\n\n");
        $processed_string++;
       }
     }
   }
  #     
  chop($patch_content); chop($patch_content);
 #  :  TXT-
 }
#  :  TeamBG BG2 TLK Editor
elsif($FORM{'patch_format'} eq "teambg_txt")
 {
  $stat_info .= "-> TXT (BG2 TLK Editor  TeamBG)<br>";

  my $BINFile_strings_data_table;
  my $BINFile_strings_content;

	#  :     
  if($FORM{'sorting_by_string_number'} eq 1)
   {
    $stat_info .= "->     <br>";

    for my $cn (0..$#patch_strings)
		 { $patch_elements{$patch_strings[$cn]} = @patch_content[$cn]; }

    if($file_version eq "V3.0")
     { $stat_info .= (":        TLK V3.0!<br>"); reset_document(); }
    elsif($file_version eq "V1  ")
     {
      foreach my $n (sort {$a <=> $b} keys %patch_elements)
       {
        # ,   ,  ,  
        my $current_StringData = substr $strings_data_table,26*$n,18;
        #   
        my $curent_StringContent = $patch_elements{$n};

        #    
        $BINFile_strings_data_table .= $current_StringData.get_DWORD_symbols(length $strings_content).get_DWORD_symbols(length $curent_StringContent);
        #   
        $BINFile_strings_content .= $curent_StringContent;

        #       
        my $in_patch_string_number = "000000".$processed_string;
        #   
        $patch_content .= ("<".(substr $in_patch_string_number,-7).">".$curent_StringContent."<END>\r\n");

        $processed_string++;
       }
     }
   #  :     
   }
  #  :      
  elsif($FORM{'sorting_by_string_number'} eq 0)
   {
    $stat_info .= "->      <br>";
    if($file_version eq "V3.0")
     { $stat_info .= ":        TLK V3.0!<br>"; reset_document(); }
    elsif($file_version eq "V1  ")
     {
      for my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];
        my $current_StringData = substr $strings_data_table,26*$n,18;
        my $curent_StringContent = @patch_content[$cn];

        $BINFile_strings_data_table .= $current_StringData.get_DWORD_symbols(length $strings_content).get_DWORD_symbols(length $curent_StringContent);
        $BINFile_strings_content .= $curent_StringContent;

        my $in_patch_string_number = "000000".$processed_string;
        $patch_content .= ("<".(substr $in_patch_string_number,-7).">".$curent_StringContent."<END>\r\n");

        $processed_string++;
       }
     }
   #  :      
   }
  #       bin-
  if((length $BINFile_strings_data_table)/26 ne $processed_string)
   { $stat_info .= ":   (".(length $BINFile_strings_data_table).")    !<br>"; reset_document(); };
  #    bin-
  $file_header = "TLK "."V1  ".get_WORD_symbols(0).get_DWORD_symbols($processed_string).get_DWORD_symbols(18+$processed_string*26);
  if(length $file_header ne 18)
   { $stat_info .= ":   (".(length $file_header).")  !<br>"; reset_document(); };


  #     bin-
  if($FORM{'make_backup'} eq 1 && -r ($save_patch_folder.$patch_file_name.".bin"))
   {
    my $backup_number = 0;
    while(-r ($save_patch_folder.$patch_file_name.".bin.backup".$backup_number))
     { $backup_number++ };
    rename $save_patch_folder.$patch_file_name.".bin", ($save_patch_folder.$patch_file_name.".bin.backup".$backup_number);
    $backup_stat = " bin-  :<br><nobr>".$save_patch_folder.$patch_file_name.".bin.backup".$backup_number."</nobr><br>";
   };

  #   bin-
  open FILE,">".$save_patch_folder.$patch_file_name.".bin";
  binmode FILE; print FILE $file_header.$BINFile_strings_data_table; close FILE;
  $stat_info .= " bin-:<br><nobr>".$save_patch_folder.$patch_file_name.".bin</nobr><br>".$backup_stat."<br>";

 #  :  TeamBG BG2 TLK Editor
 }
#  :  BG File Format Hacking Project
elsif($FORM{'patch_format'} eq "hack_proj_patch")
 {
  $stat_info .= "-> PATCH (BG File Format Hacking Project)<br>";
  if($FORM{'sorting_by_string_number'} eq 1)
   {
    $stat_info .= "->     <br>";
    foreach my $cn (sort {$a <=> $b} keys %patch_elements)
     { $patch_content .= ("> ".$cn."\n".$patch_elements{$cn}."\n");
       $processed_string++; }
   }
  elsif($FORM{'sorting_by_string_number'} eq 0)
   {
    $stat_info .= "->      <br>";
    foreach my $cn (0..$#patch_strings)
     { $patch_content .= ("> ".@patch_strings[$cn]."\n".@patch_content[$cn]."\n");
       $processed_string++; }
   }
  #    
  chop($patch_content);
 #  :  BG File Format Hacking Project
 }
#  : TRA+TP2 (WeiDU )
elsif($FORM{'patch_format'} eq "pack_weidu")
 {
  # tp2- 
  $patch_content = "//    TLK-   Nightfall's Utilites\n\nBACKUP ~".$patch_file_name."\\Backup~\nAUTHOR ~  Nightfall's Utilites~\n\nBEGIN ~".$patch_file_name."~\n\n";

  $stat_info .= "-> TRA+TP2 (WeiDU )<br>";
  if($FORM{'sorting_by_string_number'} eq 1)
   {
    $stat_info .= "->     <br>";
    for my $cn (0..$#patch_strings)
		 { $patch_elements{$patch_strings[$cn]} = @patch_content[$cn]; }

    if($file_version eq "V3.0")
     {
      foreach my $cn (sort {$a <=> $b} keys %patch_elements)
       {
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,8; $current_SoundResRef =~ s/\W//g;
        #    
        $patch_elements{$cn} =~ s/~/{tilde}/g;
        $support_patch_content .= "@".$cn." = ~".$patch_elements{$cn}."~".(($current_SoundResRef ne "") ? " [".$current_SoundResRef."]" : "")."\n";
        $patch_content .= "STRING_SET ".$cn." @".$cn." USING ~".$patch_file_name.".tra~\n";
        $processed_string++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      foreach my $cn (sort {$a <=> $b} keys %patch_elements)
       {
        my $current_SoundResRef = substr $strings_data_table,26*$n+2,8; $current_SoundResRef =~ s/\W//g;
        #    
        $patch_elements{$cn} =~ s/~/{tilde}/g;
        $support_patch_content .= "@".$cn." = ~".$patch_elements{$cn}."~".(($current_SoundResRef ne "") ? " [".$current_SoundResRef."]" : "")."\n";
        $patch_content .= "STRING_SET ".$cn." @".$cn." USING ~".$patch_file_name.".tra~\n";
        $processed_string++;
       }
     }
   }
  elsif($FORM{'sorting_by_string_number'} eq 0)
   {
    $stat_info .= "->      <br>";
    if($file_version eq "V3.0")
     {
      foreach my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,8; $current_SoundResRef =~ s/\W//g;
        #    
        $patch_elements{$cn} =~ s/~/{tilde}/g;
        $support_patch_content .= "@".@patch_strings[$cn]." = ~".@patch_content[$cn]."~".(($current_SoundResRef ne "") ? " [".$current_SoundResRef."]" : "")."\n";
        $patch_content .= "STRING_SET ".@patch_strings[$cn]." @".@patch_strings[$cn]." USING ~".$patch_file_name.".tra~\n";
        $processed_string++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      foreach my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];
        my $current_SoundResRef = substr $strings_data_table,26*$n+2,8; $current_SoundResRef =~ s/\W//g;
        #    
        $patch_elements{$cn} =~ s/~/{tilde}/g;
        $support_patch_content .= "@".@patch_strings[$cn]." = ~".@patch_content[$cn]."~".(($current_SoundResRef ne "") ? " [".$current_SoundResRef."]" : "")."\n";
        $patch_content .= "STRING_SET ".@patch_strings[$cn]." @".@patch_strings[$cn]." USING ~".$patch_file_name.".tra~\n";
        $processed_string++;
       }
     }
    }

  #     tra- 
  my $tra_patch_folder = $save_patch_folder.$patch_file_name."\\";
  #     tra- 
  if(!-r $tra_patch_folder){ mkdir $tra_patch_folder; };

  #  tra-
  my $tra_file_name = $patch_file_name.".tra";

  #    tra
  if($FORM{'make_backup'} eq 1 && -r ($tra_patch_folder.$tra_file_name))
   {
    my $backup_number = 0;
    while(-r ($tra_patch_folder.$tra_file_name.".backup".$backup_number))
     { $backup_number++ };
    rename $tra_patch_folder.$tra_file_name, ($tra_patch_folder.$tra_file_name.".backup".$backup_number);
    $backup_stat = " tra-  :<br><nobr>".$tra_patch_folder.$tra_file_name.".backup".$backup_number."</nobr><br>";
   };

  #     tra-
  chop($support_patch_content);
  #  tra- 
  open FILE,">".$tra_patch_folder.$tra_file_name;
  binmode FILE; print FILE $support_patch_content; close FILE;
  $stat_info .= " tra-:<br><nobr>".$tra_patch_folder.$tra_file_name."</nobr><br>".$backup_stat."->  : ".$processed_string." ... ".(length $support_patch_content)." <br>";

  #     tp2-
  chop($patch_content);
 #  : TRA+TP2 (WeiDU )
 }
#  : TLK (Bioware ,  V1)
elsif($FORM{'patch_format'} eq "native_tlk_1")
 {
  $stat_info .= "-> TLK (Bioware ,  V1)<br>";

  my $new_header;
  my $new_strings_data_table;
  my $new_strings_table;

  if($FORM{'sorting_by_string_number'} eq 1)
   {
    $stat_info .= "->     <br>";
    for my $cn (0..$#patch_strings)
		 { $patch_elements{$patch_strings[$cn]} = @patch_content[$cn]; }

    if($file_version eq "V3.0")
     {
      foreach my $n (sort {$a <=> $b} keys %patch_elements)
       {
        my $current_Flags = substr $strings_data_table,40*$n,4;
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,8;
        my $current_VolumeVariance = substr $strings_data_table,40*$n+20,4;
        my $current_PitchVariance = substr $strings_data_table,40*$n+24,4;
        #   
        my $curent_StringContent = $patch_elements{$n};

        $new_strings_data_table .= get_WORD_symbols(get_DWORD($current_Flags)).$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $curent_StringContent);
        $new_strings_table .= $curent_StringContent;
        $processed_string++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      foreach my $n (sort {$a <=> $b} keys %patch_elements)
       {
        # ,   ,  ,  
        my $current_StringData = substr $strings_data_table,26*$n,18;
        #   
        my $curent_StringContent = $patch_elements{$n};

        #    
        $new_strings_data_table .= $current_StringData.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $curent_StringContent);
        #   
        $new_strings_table .= $curent_StringContent;
        #    
        $processed_string++;
       }
     }
   }
  elsif($FORM{'sorting_by_string_number'} eq 0)
   {
    $stat_info .= "->      <br>";
    if($file_version eq "V3.0")
     {
      for my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];

        my $current_Flags = substr $strings_data_table,40*$n,4;
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,8;
        my $current_VolumeVariance = substr $strings_data_table,40*$n+20,4;
        my $current_PitchVariance = substr $strings_data_table,40*$n+24,4;
        my $curent_StringContent = @patch_content[$cn];

        $new_strings_data_table .= get_WORD_symbols(get_DWORD($current_Flags)).$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $curent_StringContent);
        $new_strings_table .= $curent_StringContent;
        $processed_string++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];

        my $current_StringData = substr $strings_data_table,26*$n,18;
        my $curent_StringContent = @patch_content[$cn];

        $new_strings_data_table .= $current_StringData.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $curent_StringContent);
        $new_strings_table .= $curent_StringContent;
        $processed_string++;
       }
     }
   }
  #     
  if((length $new_strings_data_table)/26 ne $processed_string)
   { $stat_info .= ":   (".(length $new_strings_data_table).")    !<br>"; reset_document(); };
  #   
  $new_header = "TLK "."V1  ".get_WORD_symbols(0).get_DWORD_symbols($processed_string).get_DWORD_symbols(18+$processed_string*26);
  if(length $new_header ne 18)
   { $stat_info .= ":   (".(length $new_header).")  !<br>"; reset_document(); };
  #   
  $patch_content = $new_header.$new_strings_data_table.$new_strings_table;
 #  : TLK (Bioware ,  V1)
 }
#  : TLK (Bioware ,  V3.0)
elsif($FORM{'patch_format'} eq "native_tlk_3")
 {
  $stat_info .= "-> TLK (Bioware ,  V3.0)<br>";

  my $new_header;
  my $new_strings_data_table;
  my $new_strings_table;

  if($FORM{'sorting_by_string_number'} eq 1)
   {
    $stat_info .= "->     <br>";
    for my $cn (0..$#patch_strings)
		 { $patch_elements{$patch_strings[$cn]} = @patch_content[$cn]; }

    if($file_version eq "V3.0")
     {
      foreach my $n (sort {$a <=> $b} keys %patch_elements)
       {
        # ,   ,  ,  
        my $current_StringData = substr $strings_data_table,26*$n,28;
        #   
        my $curent_StringContent = $patch_elements{$n};
        #   
        my $current_SoundLength = substr $strings_data_table,40*$n+36,4;

        $new_strings_data_table .= $current_StringData.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $curent_StringContent).$current_SoundLength;
        $new_strings_table .= $curent_StringContent;
        $processed_string++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      foreach my $n (sort {$a <=> $b} keys %patch_elements)
       {
        my $current_Flags = substr $strings_data_table,26*$n,2;
        my $current_SoundResRef = substr $strings_data_table,26*$n+2,8;
        my $current_VolumeVariance = substr $strings_data_table,26*$n+10,4;
        my $current_PitchVariance = substr $strings_data_table,26*$n+14,4;
        #   
        my $curent_StringContent = $patch_elements{$n};

        #    
        $new_strings_data_table .= get_DWORD_symbols(get_WORD($current_Flags)).$current_SoundResRef.get_DWORD_symbols(0).get_DWORD_symbols(0).$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $curent_StringContent).(pack "f", 0);
        #   
        $new_strings_table .= $curent_StringContent;
        #    
        $processed_string++;
       }
     }
   }
  elsif($FORM{'sorting_by_string_number'} eq 0)
   {
    $stat_info .= "->      <br>";
    if($file_version eq "V3.0")
     {
      for my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];

        my $current_StringData = substr $strings_data_table,26*$n,28;
        my $curent_StringContent = @patch_content[$cn];
        my $current_SoundLength = substr $strings_data_table,40*$n+36,4;

        $new_strings_data_table .= $current_StringData.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $curent_StringContent).$current_SoundLength;
        $new_strings_table .= $curent_StringContent;
        $processed_string++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $cn (0..$#patch_strings)
       {
        my $n = @patch_strings[$cn];

        my $current_Flags = substr $strings_data_table,26*$n,2;
        my $current_SoundResRef = substr $strings_data_table,26*$n+2,8;
        my $current_VolumeVariance = substr $strings_data_table,26*$n+10,4;
        my $current_PitchVariance = substr $strings_data_table,26*$n+14,4;
        my $curent_StringContent = @patch_content[$cn];

        $new_strings_data_table .= get_DWORD_symbols(get_WORD($current_Flags)).$current_SoundResRef.get_DWORD_symbols(0).get_DWORD_symbols(0).$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $curent_StringContent).(pack "f", 0);
        $new_strings_table .= $curent_StringContent;
        $processed_string++;
       }
     }
   }
  #     
  if((length $new_strings_data_table)/40 ne $processed_string)
   { $stat_info .= ":   (".(length $new_strings_data_table).")    !<br>";
     reset_document(); };
  #   
  $new_header = "TLK "."V3.0".get_DWORD_symbols(0).get_DWORD_symbols($processed_string).get_DWORD_symbols(20+$processed_string*40);
  if(length $new_header ne 20)
   { $stat_info .= ":   (".(length $new_header).")  !<br>";
     reset_document(); };
  #   
  $patch_content = $new_header.$new_strings_data_table.$new_strings_table;
 #  : TLK (Bioware ,  V3.0)
 }
#  : csv-
elsif($FORM{'patch_format'} eq "strings_csv")
 {
  $stat_info .= "-> CSV ( )<br>->      <br>";
  foreach my $cn (0..$#patch_strings)
   {
    $processed_string++;
    my $current_string_number = @patch_strings[$cn];
    if($patch_content !=~ /$current_string_number/)
     { $patch_content .= ($current_string_number."\;".$processed_string."\n"); };
   }
  #    
  chop($patch_content);
 #  : csv-
 }
#  : num-
elsif($FORM{'patch_format'} eq "strings_num")
 {
  $stat_info .= "-> NUM (  )<br>";
  if($FORM{'sorting_by_string_number'} eq 1)
   {
    $stat_info .= "->     <br>";
    foreach my $cn (sort {$a <=> $b} @patch_strings)
     { $patch_content .= ($cn.",");
       $processed_string++; };
   }
  elsif($FORM{'sorting_by_string_number'} eq 0)
   {
    $stat_info .= "->      <br>";
    foreach my $cn (@patch_strings)
     { $patch_content .= ($cn.",");
       $processed_string++; };
   }
  #    (,)
  chop($patch_content);
 #  : num-
 }

#   
if($FORM{'make_backup'} eq 1 && -r ($save_patch_folder.$patch_file_name.".".$patch_file_ext))
 {
  my $backup_number = 0;
  while(-r ($save_patch_folder.$patch_file_name.".".$patch_file_ext.".backup".$backup_number))
   { $backup_number++ };
  rename $save_patch_folder.$patch_file_name.".".$patch_file_ext, ($save_patch_folder.$patch_file_name.".".$patch_file_ext.".backup".$backup_number);
  $backup_stat = "   :<br><nobr>".$save_patch_folder.$patch_file_name.".".$patch_file_ext.".backup".$backup_number."</nobr><br>";
 };
#    ()
open FILE,">".$save_patch_folder.$patch_file_name.".".$patch_file_ext;
binmode FILE; print FILE $patch_content; close FILE;
$stat_info .= "<nobr> ".$patch_file_ext."-:<br><nobr>".$save_patch_folder.$patch_file_name.".".$patch_file_ext."</nobr><br>->  : ".(length $patch_content)." <br>".$backup_stat."->    tlk-: ".$processed_string."<br>";

# ,        
reset_document();
